#!/usr/bin/perl

package RatsServerLib;
require 5.001;
require "/usr/local/accounts/lib/RatsClientLib.pm";
require "/usr/local/accounts/etc/rats_internal.conf";


use DBI;
#DBI->trace( 16, '/tmp/dbitrace.log' ) ;
use Sys::Hostname;
use File::Basename;
$do = \&RatsClientLib::send_remote_command;
$c_port=$CONFIG::CLIENT_PORT;
$s_port=$CONFIG::SERVER_PORT;
$master = $CONFIG::RATS_MASTER;


my $debug = $CONFIG::COMMAND_HOOKS{'DEBUG'};
my $log = $CONFIG::COMMAND_HOOKS{'LOG'};

my ($old_address, $new_address) = @ARGV;
unless ($old_address && $new_address) {
    print "Not enough arguments\n";
    exit 1;
}

my ($old_netid, $stuff) = split("@", $old_address);
$old_netid =~ s/\+.*$//;

my ($netid, $stuff) = split("@", $new_address);
$netid =~ s/\+.*$//;

my $response = &$do('GETIRFL_U', $netid, $master, $s_port);
my ($code, @data) = split(":", $response);
unless ($code eq $CONFIG::API{'RETIRFL_U'}) {
    print "Couldn't find an RCPID for $netid: error $code, @data\n";
    exit 1;
}

$rcpid = $data[1];

$response = &$do('GETALLR', $rcpid, $master, $s_port);
my ($code, @data) = split(":", $response);
unless ($code eq $CONFIG::API{'R_GETALLR'}) {
    print "Couldn't find delivery addresses for $netid/$rcpid. This might be ok\n";
    exit 1;
}

foreach my $email_role (@data) {
        $current_email="NOT SET";
        $result = &$do('GETEMAIL', $rcpid, $email_role, $master, $s_port);
        ($code, @data) = split (":", $result);
        if ($code == $CONFIG::API{'RETEMAIL'}) {
            unless ($data[0] =~ /^\s*$/ ) {
                $current_email = $data[0];
            }
        }
	if ($current_email =~ m/^$old_netid[+@]/i) {
            print "$netid has their OLD NETID ($old_netid) referenced in their email address for role $email_role ($current_email)\n";
        }
}
